(() => {
	
	const downloader = document.querySelector('#sw-download');
	const installer = document.querySelector('#sw-install');
	const remover = document.querySelector('#sw-remove');
	const results = document.querySelector('.results');
	
	const addResult = text => {
		const div = document.createElement('div');
		div.appendChild(new Text(text));
		results.appendChild(div);
	};
	
	const reloadPage = txt => {
		addResult(txt);
		addResult('Page will reload in 3 seconds...');
		setTimeout(() => window.location.reload(), 3000);
	};
	
	installer.addEventListener('click', () => {
		navigator.serviceWorker
				.register('./service-worker.js')
				.then(() => reloadPage('OK - malicious service worker is installed'))
				.catch(e => addResult('ERR - Cannot install worker, ' + e));
	});
	
	remover.addEventListener('click', () => {
		navigator.serviceWorker
				.getRegistrations()
				.then(rgs => {
					if (rgs.every(rg => rg.unregister())) {
						reloadPage('OK - All workers are unregistered');
					} else {
						addResult('ERR - Cannot unregister the workers');
					}
				});
	});
	
	downloader.addEventListener('click', () => {
		fetch('./service-worker-data.txt')
				.then(r => r.text())
				.then(t => addResult(t));
	});
})();
